Index: /java/main/src/main/java/com/framsticks/communication/ClientConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 90)
@@ -45,5 +45,5 @@
 	protected void joinableStart() {
 		try {
-			log.info("connecting to " + address);
+			log.debug("connecting to " + address);
 
 			socket = new Socket(hostName, port);
@@ -51,5 +51,5 @@
 			socket.setSoTimeout(500);
 
-			log.info("connected to " + hostName + ":" + port);
+			log.debug("connected to " + hostName + ":" + port);
 			connected = true;
 			runThreads();
@@ -145,5 +145,5 @@
 
 		public void dispatchResponseProcess(final Response response) {
-			Dispatching.invokeLaterOrNow(dispatcher, new RunAt<C>() {
+			Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>() {
 				@Override
 				public void run() {
@@ -193,5 +193,5 @@
 		sentQuery.dispatcher = dispatcher;
 
-		senderThread.invokeLater(new RunAt<Connection>(){
+		senderThread.dispatch(new RunAt<Connection>(){
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 90)
@@ -135,5 +135,5 @@
 		Dispatching.use(threads, this);
 
-		receiverThread.invokeLater(new RunAt<Connection>() {
+		receiverThread.dispatch(new RunAt<Connection>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/communication/ServerConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 90)
@@ -66,5 +66,5 @@
 
 	protected final void respond(final Response response, final Integer id) {
-		senderThread.invokeLater(new RunAt<Connection>() {
+		senderThread.dispatch(new RunAt<Connection>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/communication/Subscription.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 90)
@@ -75,5 +75,5 @@
 
 	public void dispatchCall(final List<File> files) {
-		Dispatching.invokeLaterOrNow(dispatcher, new RunAt<C>() {
+		Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 90)
@@ -4,5 +4,5 @@
 import com.framsticks.parsers.XmlLoader;
 import com.framsticks.util.dispatching.JoinableCollection;
-import com.framsticks.util.dispatching.JoinableMonitor;
+import com.framsticks.util.dispatching.Monitor;
 
 import org.apache.log4j.Logger;
@@ -23,17 +23,14 @@
 
 	public static Framsticks loadConfiguration(InputStream stream) {
-		return new XmlLoader().load(stream, Framsticks.class);
+		return new XmlLoader().load(Framsticks.class, stream);
 	}
 
 	public static void main(final String[] args) {
 
-		final Framsticks framsticks = loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml"));
-
-		new JoinableMonitor(framsticks).use().waitFor().drop().join();
-
-		// monitor.use();
-		// monitor.waitFor();
-		// monitor.drop();
-		// monitor.join();
+		new Monitor(loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml")))
+			.use()
+			.waitFor()
+			.drop()
+			.join();
 
 		log.info("exiting main");
Index: /java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 90)
@@ -8,5 +8,4 @@
 
 import javax.annotation.Nonnull;
-import javax.annotation.OverridingMethodsMustInvokeSuper;
 
 import org.apache.log4j.Logger;
@@ -14,14 +13,19 @@
 import com.framsticks.communication.File;
 import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
 import com.framsticks.params.ConstructionException;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.ListAccess;
 import com.framsticks.params.Param;
+import com.framsticks.params.ParamsPackage;
 import com.framsticks.params.Registry;
 import com.framsticks.params.ValueParam;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.types.ObjectParam;
+import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.parsers.Loaders;
 import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.StateFunctor;
 import com.framsticks.util.UnsupportedOperationException;
@@ -40,5 +44,25 @@
 	private static final Logger log = Logger.getLogger(Instance.class.getName());
 
-	protected Node root;
+	private Node root;
+
+	protected @Nonnull Node setRoot(CompositeParam param, Object object) {
+		// if (isRootAssigned()) {
+		// 	throw new FramsticksException().msg("root is already assigned");
+		// }
+		// assert isActive();
+		root = new Node(param, object);
+		return root;
+	}
+
+	protected @Nonnull Node getRoot() {
+		// assert isActive();
+		assert root != null;
+		return root;
+	}
+
+	public boolean isRootAssigned() {
+		// assert isActive();
+		return root != null;
+	}
 
 	protected Set<InstanceListener> listeners = new HashSet<InstanceListener>();
@@ -68,11 +92,18 @@
 	}
 
-	public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
-		stateFunctor.call(null);
-	}
-
-	public void fetchValues(Path path, StateFunctor stateFunctor) {
-		stateFunctor.call(null);
-	}
+	/** This is part of the Instance interface.
+	 *
+	 */
+	public abstract void fetchValue(Path path, Param param, StateFunctor stateFunctor);
+
+	/** This is part of the Instance interface.
+	 *
+	 */
+	public abstract void fetchValues(Path path, StateFunctor stateFunctor);
+
+	/** This is part of the Instance interface.
+	 *
+	 */
+	public abstract void call(Path path, ProcedureParam param, Object[] arguments, StateFunctor stateFunctor);
 
 	protected void tryRegisterOnChangeEvents(Path path) {
@@ -82,5 +113,5 @@
 	public void storeValue(Path path, Param param, Object value, final StateFunctor stateFunctor) {
 		assert isActive();
-		invokeLater(new RunAt<Instance>() {
+		dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -104,5 +135,5 @@
 	public void addListener(final InstanceListener listener) {
 		assert Dispatching.isThreadSafe();
-		Dispatching.invokeLaterOrNow(this, new RunAt<Instance>() {
+		Dispatching.dispatchIfNotActive(this, new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -114,5 +145,5 @@
 	public void removeListener(final InstanceListener listener) {
 		assert Dispatching.isThreadSafe();
-		Dispatching.invokeLaterOrNow(this, new RunAt<Instance>() {
+		Dispatching.dispatchIfNotActive(this, new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -142,5 +173,5 @@
 	public FramsClass getInfoFromCache(String id) {
 		assert isActive();
-		return registry.getInfoFromCache(id);
+		return registry.getFramsClass(id);
 	}
 
@@ -169,9 +200,18 @@
 	}
 
+	public final AccessInterface bindAccess(String path) {
+		return bindAccess(getPath(path));
+	}
+
 	public final AccessInterface bindAccess(Node node) {
+		assert isActive();
 		assert node.getObject() != null;
 
 		try {
-			return registry.prepareAccess(node.getParam()).select(node.getObject());
+			AccessInterface access = registry.prepareAccess(node.getParam());
+			if (access == null) {
+				throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam());
+			}
+			return access.select(node.getObject());
 		} catch (ConstructionException e) {
 			log.error("failed to bind access for " + node.getParam() + ": " + e);
@@ -185,5 +225,5 @@
 
 	public final AccessInterface bindAccess(Path path) {
-		assert path.isResolved();
+		path.assureResolved();
 		return bindAccess(path.getTop());
 	}
@@ -260,5 +300,5 @@
 			assert child != null;
 			if (path.size() == 1) {
-				root = new Node(root.getParam(), child);
+				setRoot(getRoot().getParam(), child);
 			} else {
 				bindAccess(path.getUnder()).set(path.getTop().getParam(), child);
@@ -277,9 +317,9 @@
 		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
 		if ("/".equals(file.getPath())) {
-			if (root.getParam().getContainedTypeName() == null) {
-				root = new Node(Param.build().name("Instance").id(getName()).type("o " + framsClass.getId()), root.getObject());
-			}
-		}
-		registry.putInfoIntoCache(framsClass);
+			if (getRoot().getParam().getContainedTypeName() == null) {
+				setRoot(Param.build().name("Instance").id(getName()).type("o " + framsClass.getId()).finish(CompositeParam.class), getRoot().getObject());
+			}
+		}
+		registry.putFramsClass(framsClass);
 		return framsClass;
 	}
@@ -299,7 +339,4 @@
 				loader.go();
 				fireFetch(path);
-	//            for (NodeListener l : listeners) {
-	//                l.onChange(this);
-	//            }
 				return;
 			}
@@ -318,5 +355,5 @@
 					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
 					//TODO listAccessParam
-					Param param = Param.build().type("o " + accessInterface.getId()).id(id).finish();
+					Param param = Param.build().forAccess(accessInterface).id(id).finish();
 					Object child = accessInterface.getSelected();
 					accessInterface.select(null);
@@ -327,7 +364,4 @@
 
 			fireFetch(path);
-	//        for (NodeListener l : listeners) {
-	//            l.onChange(this);
-	//        }
 		} catch (Exception e) {
 			log.error("exception occurred while loading: " + e);
@@ -358,9 +392,27 @@
 	}
 
+	@AutoAppendAnnotation
+	public void usePackage(ParamsPackage paramsPackage) {
+		log.debug("using package " + paramsPackage + " in instance " + this);
+		paramsPackage.register(registry);
+	}
+
+	@AutoAppendAnnotation
+	public void takeFromRegistry(Registry registry) {
+		log.debug("taking from registry " + registry + " in instance " + this);
+		this.registry.takeAllFrom(registry);
+	}
+
 	@Override
-	@OverridingMethodsMustInvokeSuper
-	protected void firstTask() {
-		root = new Node(Param.build().name("Instance").id(getName()).type("o"), null);
-		com.framsticks.model.Package.register(registry);
+	protected void joinableStart() {
+		dispatch(new RunAt<Instance>() {
+			@Override
+			public void run() {
+				if (!isRootAssigned()) {
+					setRoot(Param.build().name("Instance").id(getName()).type("o").finish(CompositeParam.class), null);
+				}
+			}
+		});
+		super.joinableStart();
 	}
 
Index: /java/main/src/main/java/com/framsticks/core/LocalInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 90)
@@ -50,5 +50,5 @@
 
 	protected void acceptNext() {
-		acceptThread.invokeLater(new RunAt<Accept>() {
+		acceptThread.dispatch(new RunAt<Accept>() {
 			@Override
 			public void run() {
@@ -57,5 +57,5 @@
 					assert socket != null;
 					log.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
-					invokeLater(new RunAt<LocalInstance>() {
+					dispatch(new RunAt<LocalInstance>() {
 						@Override
 						public void run() {
@@ -74,5 +74,5 @@
 
 	public void tryBind(final Integer accept) {
-		acceptThread.invokeLater(new RunAt<Accept>() {
+		acceptThread.dispatch(new RunAt<Accept>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/core/Node.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Node.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/core/Node.java	(revision 90)
@@ -29,5 +29,5 @@
 
 	public Node(@Nonnull ParamBuilder builder, Object object) {
-		this((CompositeParam) builder.finish(), object);
+		this(builder.finish(CompositeParam.class), object);
 	}
 
Index: /java/main/src/main/java/com/framsticks/core/ObjectInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/ObjectInstance.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/core/ObjectInstance.java	(revision 90)
@@ -0,0 +1,65 @@
+package com.framsticks.core;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.Param;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.StateFunctor;
+
+@FramsClassAnnotation
+public class ObjectInstance extends Instance {
+	private static final Logger log = Logger.getLogger(ObjectInstance.class);
+
+	@AutoAppendAnnotation
+	public void setRootObject(Object object) {
+		registry.registerAndBuild(object.getClass());
+		AccessInterface access = registry.createAccess(object.getClass());
+		setRoot(Param.build().forAccess(access).id(getName()).finish(CompositeParam.class), object);
+	}
+
+	public Object getRootObject() {
+		return getRoot().getObject();
+	}
+
+	public <T> T getRootObject(Class<T> type) {
+		Object result = getRootObject();
+		if (result == null) {
+			throw new FramsticksException().msg("object instance is empty").arg("instance", this);
+		}
+		if (!type.isInstance(result)) {
+			throw new FramsticksException().msg("object instance holds object of different kind").arg("object", result).arg("requested", type).arg("instance", this);
+		}
+		return type.cast(result);
+	}
+
+	@Override
+	public void fetchValues(final Path path, final StateFunctor stateFunctor) {
+		assert isActive();
+		log.debug("requesting: " + path);
+		fireFetch(path);
+		stateFunctor.call(null);
+	}
+
+	@Override
+	public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
+		assert isActive();
+		fireFetch(path);
+		stateFunctor.call(null);
+	}
+
+	@Override
+	public void call(Path path, ProcedureParam param, Object[] arguments, StateFunctor stateFunctor) {
+		assert isActive();
+		try {
+			bindAccess(path).call(param, arguments);
+			stateFunctor.call(null);
+		} catch (FramsticksException e) {
+			stateFunctor.call(e);
+		}
+	}
+}
Index: /java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Path.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/core/Path.java	(revision 90)
@@ -4,4 +4,5 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.Param;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatching;
 
@@ -30,5 +31,10 @@
 			return null;
 		}
-		return (instance.registry.prepareAccess(param) != null) ? child : null;
+		try {
+			instance.registry.prepareAccess(param);
+			return child;
+		} catch (FramsticksException e) {
+		}
+		return null;
 	}
 
@@ -119,6 +125,6 @@
 			this.instance = instance;
 
-			nodes.add(instance.root);
-			Node current = instance.root;
+			nodes.add(instance.getRoot());
+			Node current = instance.getRoot();
 
 			StringBuilder b = new StringBuilder();
@@ -254,4 +260,10 @@
 		return ListUtils.unmodifiableList(nodes);
 	}
+
+	public void assureResolved() {
+		if (!isResolved()) {
+			throw new FramsticksException().msg("path is not resolved").arg("path", this);
+		}
+	}
 }
 
Index: /java/main/src/main/java/com/framsticks/dumping/FileInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 90)
@@ -7,4 +7,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.io.Encoding;
 
@@ -17,5 +18,4 @@
 import java.io.InputStreamReader;
 
-import javax.annotation.OverridingMethodsMustInvokeSuper;
 
 /**
@@ -23,5 +23,5 @@
  */
 @FramsClassAnnotation
-public class FileInstance extends LocalInstance {
+public abstract class FileInstance extends LocalInstance {
 
 	private static final Logger log = Logger.getLogger(Instance.class.getName());
@@ -42,34 +42,39 @@
 
 	@Override
-	@OverridingMethodsMustInvokeSuper
-	protected void firstTask() {
-		assert isActive();
-		super.firstTask();
-		try {
-			LoadStream stream = new LoadStream(this.getRootPath(), new BufferedReader(new InputStreamReader(new FileInputStream(file), Encoding.getFramsticksCharset())), this, new Future<Path>() {
-				@Override
-				public void result(Path result, Exception e) {
-					if (e != null) {
-						log.error("failed to load file instance " + FileInstance.this + ": " + e);
-						fireRun(e);
-						return;
-					}
-					log.info("loaded file instance " + FileInstance.this);
-					fireRun(null);
-				}
-			});
-			stream.load();
-		} catch (IOException e) {
-			log.error("io failure: " + e);
-			fireRun(e);
-		}
-	}
-
-	@Override
 	public String toString() {
 		return "file@" + file.getName();
 	}
 
+	@Override
+	protected void joinableStart() {
+		dispatch(new RunAt<Instance>() {
 
+			@Override
+			public void run() {
+				assert isActive();
+
+				try {
+					LoadStream stream = new LoadStream(FileInstance.this.getRootPath(), new BufferedReader(new InputStreamReader(new FileInputStream(file), Encoding.getFramsticksCharset())), FileInstance.this, new Future<Path>() {
+						@Override
+						public void result(Path result, Exception e) {
+							if (e != null) {
+								log.error("failed to load file instance " + FileInstance.this + ": " + e);
+								fireRun(e);
+								return;
+							}
+							log.info("loaded file instance " + FileInstance.this);
+							fireRun(null);
+						}
+					});
+					stream.load();
+				} catch (IOException e) {
+					log.error("io failure: " + e);
+					fireRun(e);
+				}
+			}
+
+		});
+		super.joinableStart();
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 90)
@@ -44,5 +44,5 @@
 	protected void dispatchWrite(final Path path) {
 		++dispatched;
-		instance.invokeLater(new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 90)
@@ -69,5 +69,5 @@
 	public void autoResolvePath(final String path, final Future<Path> future) {
 		final Instance i = instances.get("localhost");
-		i.invokeLater(new RunAt<Instance>() {
+		i.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -80,5 +80,5 @@
 						}
 						if (e == null) {
-							mainFrame.invokeLater(new RunAt<Frame>() {
+							mainFrame.dispatch(new RunAt<Frame>() {
 								@Override
 								public void run() {
@@ -100,7 +100,7 @@
 	}
 
-	protected void firstTask() {
+	protected void initializeGUI() {
 		assert isActive();
-		log.info("executing first task");
+		log.debug("executing first task");
 
 		try {
@@ -129,9 +129,9 @@
 
 		for (final Instance i : instances) {
-			i.invokeLater(new RunAt<Instance>() {
+			i.dispatch(new RunAt<Instance>() {
 				@Override
 				public void run() {
 					final Path p = i.getRootPath();
-					invokeLater(new RunAt<Browser>() {
+					dispatch(new RunAt<Browser>() {
 						@Override
 						public void run() {
@@ -183,8 +183,8 @@
 		Dispatching.use(instances, this);
 
-		invokeLater(new RunAt<Browser>() {
+		dispatch(new RunAt<Browser>() {
 			@Override
 			public void run() {
-				firstTask();
+				initializeGUI();
 			}
 		});
@@ -227,6 +227,6 @@
 
 	@Override
-	public void invokeLater(RunAt<? extends Browser> runnable) {
-		SwingDispatcher.getInstance().invokeLater(runnable);
+	public void dispatch(RunAt<? extends Browser> runnable) {
+		SwingDispatcher.getInstance().dispatch(runnable);
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 90)
@@ -285,6 +285,6 @@
 
 	@Override
-	public void invokeLater(RunAt<? extends Frame> runnable) {
-		SwingDispatcher.getInstance().invokeLater(runnable);
+	public void dispatch(RunAt<? extends Frame> runnable) {
+		SwingDispatcher.getInstance().dispatch(runnable);
 	}
 
@@ -427,5 +427,5 @@
 		super.joinableInterrupt();
 
-		invokeLater(new RunAt<Frame>() {
+		dispatch(new RunAt<Frame>() {
 			@Override
 			public void run() {
Index: /java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 90)
@@ -14,4 +14,5 @@
 import com.framsticks.gui.controls.CheckBoxControl;
 import com.framsticks.gui.controls.Control;
+import com.framsticks.gui.controls.ControlOwner;
 import com.framsticks.gui.controls.EnumControl;
 import com.framsticks.gui.controls.EventControl;
@@ -33,4 +34,5 @@
 import com.framsticks.params.types.StringParam;
 import com.framsticks.params.types.UniversalParam;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Strings;
 
@@ -92,20 +94,26 @@
 	}
 
-	public static void fillWithControls(JPanel panel, Collection<Param> params, Map<Param, Control> components) {
-		for (Param param : params) {
+	public static <P extends Param, C extends Control> void fillWithControls(ControlOwner owner, Collection<P> params, Map<P, C> components, Class<C> controlType) {
+		JPanel panel = owner.getPanel();
+		for (P param : params) {
 			if (param.isUserHidden()) {
 				continue;
 			}
 			assert !(param instanceof CompositeParam);
-			Control control = Gui.createSuitable(param);
-			if (control == null) {
-				log.error("component for param " + param + " of type " + param.getClass().getSimpleName() + " was not added");
-				continue;
+			Control c = Gui.createSuitable(param);
+
+			if (!controlType.isInstance(c)) {
+				throw new FramsticksException().msg("created control is not of required type").arg("control", c).arg("type", controlType);
 			}
+
+			C control = controlType.cast(c);
+
+			control.setOwner(owner);
+
 			log.debug("add component for " + param);
 			JPanel line = new JPanel();
 			line.setLayout(new BoxLayout(line, BoxLayout.LINE_AXIS));
 			line.setAlignmentX(JPanel.LEFT_ALIGNMENT);
-			JLabel label = new JLabel(Strings.notEmpty(param.getName()) ? param.getName() : "? (" + param.getId() + ")");
+			JLabel label = new JLabel(Strings.notEmpty(param.getName()) ? param.getName() : (Strings.notEmpty(param.getId()) ? param.getId() : "?"));
 			label.setToolTipText(control.getToolTipText());
 			label.setHorizontalAlignment(JLabel.RIGHT);
Index: /java/main/src/main/java/com/framsticks/gui/InstanceAtFrame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/InstanceAtFrame.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/InstanceAtFrame.java	(revision 90)
@@ -72,6 +72,5 @@
 		List<Panel> panels = new ArrayList<Panel>();
 
-		Panel.Parameters parameters = new Panel.Parameters(this, param,
-				framsClass);
+		Panel.Parameters parameters = new Panel.Parameters(this, param, framsClass);
 		for (PanelProvider pp : frame.browser.panelProviders) {
 			Panel p = pp.providePanel(parameters);
@@ -150,5 +149,5 @@
 		log.trace("fetched " + path);
 
-		frame.invokeLater(new RunAt<Frame>() {
+		frame.dispatch(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -159,5 +158,5 @@
 				final TreeNode result = (TreeNode) treePath.getLastPathComponent();
 				// log.trace("found " + result + " == " + path);
-				instance.invokeLater(new RunAt<Instance>() {
+				instance.dispatch(new RunAt<Instance>() {
 					@Override
 					public void run() {
Index: /java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 90)
@@ -2,4 +2,5 @@
 
 import com.framsticks.gui.controls.Control;
+import com.framsticks.gui.controls.ControlOwner;
 import com.framsticks.gui.controls.ValueControl;
 import com.framsticks.gui.controls.ValueControlListener;
@@ -11,4 +12,5 @@
 
 import javax.swing.*;
+
 import java.util.Collection;
 import java.util.HashMap;
@@ -18,5 +20,5 @@
 
 @SuppressWarnings("serial")
-public class ObjectPanel extends ModifiablePanel {
+public class ObjectPanel extends ModifiablePanel implements ControlOwner {
 
 	private static final Logger log = Logger.getLogger(ObjectPanel.class.getName());
@@ -28,5 +30,6 @@
 		super(parameters);
 
-		Gui.fillWithControls(contentPanel, params, components);
+		Gui.fillWithControls(this, params, components, Control.class);
+		setName(framsClass.getId());
 
 		for (final ValueControl c : filterInstanceof(components.values(), ValueControl.class)) {
@@ -44,4 +47,5 @@
 			});
 		}
+
 		contentPanel.add(Box.createVerticalGlue());
 		this.revalidate();
@@ -74,5 +78,5 @@
 		}
 
-		frame.invokeLater(new RunAt<Frame>() {
+		frame.dispatch(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -97,25 +101,34 @@
 	}
 
+	@Override
+	public JPanel getPanel() {
+		return contentPanel;
+	}
+
+	@Override
+	public TreeNode getCurrentTreeNode() {
+		return super.getCurrentTreeNode();
+	}
 
 	// public void updateValue() {
-	// 	//assert panel.getFrame().isActive();
+	//	//assert panel.getFrame().isActive();
 
-	// 	final Node n = panel.getCurrentNode();
-	// 	panel.getBrowser().getManager().invokeLater(new Runnable() {
-	// 		@Override
-	// 		public void run() {
-	// 			Object v = n.getAccess().get(param, Object.class);
-	// 			if (v == null) {
-	// 				v = param.getDef(Object.class);
-	// 			}
-	// 			final Object fv = v;
-	// 			panel.getBrowser().invokeLater(new Runnable() {
-	// 				@Override
-	// 				public void run() {
-	// 					setValueImpl(fv);
-	// 				}
-	// 			});
-	// 		}
-	// 	});
+	//	final Node n = panel.getCurrentNode();
+	//	panel.getBrowser().getManager().invokeLater(new Runnable() {
+	//		@Override
+	//		public void run() {
+	//			Object v = n.getAccess().get(param, Object.class);
+	//			if (v == null) {
+	//				v = param.getDef(Object.class);
+	//			}
+	//			final Object fv = v;
+	//			panel.getBrowser().invokeLater(new Runnable() {
+	//				@Override
+	//				public void run() {
+	//					setValueImpl(fv);
+	//				}
+	//			});
+	//		}
+	//	});
 	// }
 
Index: /java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 90)
@@ -21,5 +21,5 @@
 
 	public SwingDispatcher() {
-		invokeLater(new RunAt<C>() {
+		dispatch(new RunAt<C>() {
 			@Override
 			public void run() {
@@ -35,5 +35,5 @@
 
 	@Override
-	public final void invokeLater(RunAt<? extends C> runnable) {
+	public final void dispatch(RunAt<? extends C> runnable) {
 		assert !(runnable instanceof Task);
 		SwingUtilities.invokeLater(runnable);
